//SERIAL ANALOGUE INPUT
//this code was written for the free c compiler that comes with MPLAB.
//The RS232 signal is produced by toggling GP5 for periods determent 
//by the delay and number of instructions. The periods may vary with different
//c compiler translation to opcode.
//
// This code is free to use, for more info   http://www.moty22.co.uk 
   
#include <htc.h>

#define _XTAL_FREQ 4000000

//void init(void);

__CONFIG(MCLRDIS & WDTDIS & UNPROTECT & INTIO);

int bitcount;
bit outbit;

void init(void){

	OSCCAL = _READ_OSCCAL_DATA();	//calibrate osc
	CMCON = 0b00000111;		//comparator off
	TRISIO = 0b00011111;   //GP5 o/p
	ANSEL = 0b01010100;   //AN2 i/p
	ADCON0 = 0b00001001;	//ADC left justified
	GPIO5 = 1;
}

main(){
	init();
for(;;){	
	bitcount = 0;

	GODONE = 1;				//start ADC
	__delay_us(195);
	
	 //transmite byte1
	GPIO5 = 0;				//serial start bit 
	__delay_us(195);		
	outbit = (ADRESL >> 6);		//get the LSB
	GPIO5 = outbit;				//transmite bit 0
	__delay_us(195);
	outbit = (ADRESL >> 7);
	GPIO5 = outbit;
	__delay_us(195);
	outbit = ADRESH;
	GPIO5 = outbit; 			//transmite LSB of ADRESH
	__delay_us(195);
	GPIO5 = 0;
	__delay_us(195 * 5);
	GPIO5 = 1;				//bit 8=0
	__delay_us(195 * 3);
	
		//byte2
	GPIO5 = 0;
	__delay_us(195);

	while (bitcount < 7 ){				//transmite bits 3-9 of ADC
	outbit = (ADRESH >> bitcount + 1);
	GPIO5 = outbit;
	__delay_us(145);
			
	bitcount++;
		}
	GPIO5 = 1;				//bit 8=1
	__delay_us(10000);		//take 10ms break
	
}
}

